> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/glue-reference/screen/basescreen.md).

# BaseScreen

### Introduction

The BaseScreen value controls the base screen from which the current screen is derived. The derived screen will have all of the objects, files, events, variables, and code of the base screen, but can add more functionality and content in Glue and code. In code setting the BaseScreen sets the screen to inherit from the base screen.

![](https://951240982-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M_fye9Ufg3vzJxwX5Hk%2Fuploads%2Fgit-blob-32d90b72b49f52aaf906772c1b8820dfb8eacd59%2F2019-07-img_5d1ece07406ac.png?alt=media)

### Level Screens Using GameScreen as BaseScreen

The recommended pattern for creating multiple levels is to create one Screen (called a level Screen) for each level, each inheriting from GameScreen. As of March 2021, Glue recommends this approach by providing options to create Level screens which inherit from GameScreen.

![](https://951240982-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M_fye9Ufg3vzJxwX5Hk%2Fuploads%2Fgit-blob-75c8c66c1eb295fbd6fb2f4ac8973de13d1bac5e%2F2021-03-img_604390b11a3cc.png?alt=media)

In this case, all of the common objects (such as enemy lists, bullet lists, and collision TileShapeCollections) should be defined in the GameScreen. Similarly, CollisionRelationships should also be defined in the GameScreen. Since the level Screen uses the GameScreen as its base, then all level Screens will also have the same objects at runtime.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flatredball.com/flatredball/glue-reference/screen/basescreen.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
